﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Chart;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private bool started;
        private DataPoint selectedDataPoint;
        private double prevValue;

        public Window1()
        {
            InitializeComponent();
        }

        private void Chart_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            HitTestArgs hitArgs = this.Chart.HitTest(e);

            this.selectedDataPoint = hitArgs.SelectedObject as DataPoint;

            if (this.selectedDataPoint != null)
            {
                this.prevValue = hitArgs.YValue;
                this.Chart.Cursor = Cursors.SizeNS;
                started = true;
            }

            e.Handled = true;
        }

        private void Chart_MouseMove(object sender, MouseEventArgs e)
        {
            if (started == false || this.selectedDataPoint == null)
            {
                return;
            }

            HitTestArgs hitArgs = this.Chart.HitTest(e);

            double dy = hitArgs.YValue - prevValue;

            this.selectedDataPoint.Value += dy;

            this.prevValue = hitArgs.YValue;
        }

        private void Chart_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            if (started)
            {
                this.Chart.Cursor = Cursors.Arrow;
                started = false;
            }
        }
    }
}
